/*-
 * ~~~~~~licensing~~~~~~
 * route-producing
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.routes.design.library;

import java.util.List;

import org.osgi.framework.Filter;

public interface ComponentLibrary {

    String COMPONENT_LIBRARY_PROVIDER_HEADER = "Entaxy-Component-Library-Provider";
    String COMPONENT_LIBRARY_RESOURCE_PROTOCOL = "component-library";

    String getName();

    String getUrl();

    List<Schema> getSchemas();

    default Filter getObjectFilter() {
        return null;
    };

    public interface Schema {

        String getRoot();

        default String getRootUrl() {
            return getRoot();
        }

        String getNamespace();

        String getPrefix();

        boolean isPublic();

        default ComponentLibrary getLibrary() {
            return null;
        };

        default Filter getObjectFilter() {
            return null;
        };

        List<Transformation> getTransformations();

        String getUiDescriptor();

    }

    public interface Transformation {

        String getProcessor();

        String getSource();

        default String getSourceUrl() {
            return getSource();
        }

        default Filter getObjectFilter() {
            return null;
        };

        default ComponentLibrary.Schema getSchema() {
            return null;
        }

    }

}
